import { Command } from 'commander';
declare function init(program: Command, projectPath: string, options: InitOptions): Promise<void>;
declare function getAugmentedInitOptions(options: InitOptions, projectPath: string): Promise<AugmentedInitOptions>;
export interface InitOptions {
    name: string;
    description: string;
    subscribable: boolean;
    logo: string;
    tags: string;
    chain: string[];
    type: 'sql' | 'wasm';
}
export interface AugmentedInitOptions extends InitOptions {
    jsonTags: string;
    kebabName: string;
    defaultQuery: string;
    mamoruSdkAsVersion: string;
    mamoruCustomSdkPackageVersion: string;
    mamoruCustomSdkPackageName: string;
    customSdkCtxName: string;
    mamoruCoreVersion: string | null;
}
declare const _default: {
    init: typeof init;
    getAugmentedInitOptions: typeof getAugmentedInitOptions;
};
export default _default;
//# sourceMappingURL=init.d.ts.map