"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = __importStar(require("fs"));
var path_1 = __importDefault(require("path"));
var handlebars_1 = __importDefault(require("handlebars"));
var console_1 = require("../services/console");
var dashify_1 = __importDefault(require("dashify"));
var constants_1 = require("../services/constants");
var colors_1 = __importDefault(require("colors"));
var sdk_dependency_versions_1 = require("../sdk-dependency-versions");
var lodash_1 = require("lodash");
var prompts_1 = require("@inquirer/prompts");
var utils_1 = require("../services/utils");
function init(program, projectPath, options) {
    return __awaiter(this, void 0, void 0, function () {
        var verbosity, logger, augOps, files;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    verbosity = program.opts().verbose;
                    logger = new console_1.Logger(verbosity);
                    logger.verbose('Run init');
                    logger.verbose('options', options);
                    return [4 /*yield*/, getAugmentedInitOptions(options, projectPath)];
                case 1:
                    augOps = _a.sent();
                    files = getFilesToCreate(projectPath, augOps);
                    (0, utils_1.checkFolderEmptiness)(program, Object.values(files));
                    logger.ok('Creating Mamoru project files');
                    createFile(logger, augOps, constants_1.TEMPLATES.PACKAGE_JSON, files.PACKAGE_JSON);
                    createFile(logger, augOps, constants_1.TEMPLATES.MANIFEST, files.MANIFEST);
                    createFile(logger, augOps, constants_1.TEMPLATES.README, files.README);
                    createFile(logger, augOps, constants_1.TEMPLATES.GITIGNORE, files.GITIGNORE);
                    if (options.type === 'sql') {
                        createFile(logger, augOps, constants_1.TEMPLATES.QUERIES, files.QUERIES);
                    }
                    if (options.type === 'wasm') {
                        createFolder(logger, projectPath, 'src');
                        createFolder(logger, projectPath, 'test');
                        createFile(logger, augOps, constants_1.TEMPLATES.WASM_INDEX, files.WASM_INDEX);
                        createFile(logger, augOps, constants_1.TEMPLATES.WASM_TEST, files.WASM_TEST);
                    }
                    logger.ok('Mamoru project files created!');
                    if (options.type === 'wasm') {
                        logger.log("\n    \u2139\uFE0F To start working on your project, run:\n        \n        ".concat(colors_1.default.grey("cd ".concat(projectPath)), "\n        ").concat(colors_1.default.grey("npm install"), "\n    \n    \u2139\uFE0F To start the project locally, run:\n        \n        ").concat(colors_1.default.grey("npm run start"), "\n    \n    \u2139\uFE0F To know more about how to create your own daemons, visit:\n        \n        ").concat(colors_1.default.underline.blue('https://mamoru-foundation.github.io/guides/using-the-mamoru-cli.html'), "\n    "));
                    }
                    if (options.type === 'sql') {
                        logger.log("\n    \u2139\uFE0F To start working on your project, run:\n        \n        ".concat(colors_1.default.grey("cd ".concat(projectPath)), "\n    \n    \u2139\uFE0F To know more about how to create your own daemons, visit:\n        \n        ").concat(colors_1.default.underline.blue('https://mamoru-foundation.github.io/guides/using-the-mamoru-cli.html'), "\n    "));
                    }
                    return [2 /*return*/];
            }
        });
    });
}
function getAugmentedInitOptions(options, projectPath) {
    return __awaiter(this, void 0, void 0, function () {
        var name, chain;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!options.name && !(0, dashify_1.default)(projectPath)) {
                        name = 'Default name';
                    }
                    else {
                        name = options.name || (0, lodash_1.deburr)(path_1.default.basename(projectPath));
                    }
                    return [4 /*yield*/, queryChains(options)];
                case 1:
                    chain = _a.sent();
                    return [2 /*return*/, __assign(__assign({}, options), { name: name, jsonTags: JSON.stringify(options.tags.split(',')), kebabName: (0, dashify_1.default)(name), defaultQuery: getDefaultQuery(chain[0]), mamoruSdkAsVersion: sdk_dependency_versions_1.sdkVersions.sdk, mamoruCustomSdkPackageName: getCustomSdkPackage(chain[0]), mamoruCustomSdkPackageVersion: getCustomSdkPackageVersion(chain[0]), customSdkCtxName: getCustomSdkCtxName(chain[0]), mamoruCoreVersion: constants_1.DEFAULT_MAMORU_VERSION, chain: chain })];
            }
        });
    });
}
function queryChains(options) {
    return __awaiter(this, void 0, void 0, function () {
        var chain;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (options.chain)
                        return [2 /*return*/, options.chain];
                    return [4 /*yield*/, (0, prompts_1.checkbox)({
                            choices: (0, utils_1.getAvailableChains)().map(function (c) { return ({
                                value: c,
                            }); }),
                            message: 'Select the chain you want to use',
                        })];
                case 1:
                    chain = _a.sent();
                    if (!chain.length)
                        throw new Error('Please select at least 1 chain');
                    return [2 /*return*/, chain];
            }
        });
    });
}
function getDefaultQuery(type) {
    switch (type) {
        case 'SUI_MAINNET':
        case 'SUI_TESTNET':
            return "SELECT 1 FROM transactions t WHERE starts_with(t.digest, '0x1_this_is_an_example_query')";
        case 'BSC_TESTNET':
        case 'BSC_MAINNET':
            return "SELECT 1 FROM transactions t WHERE starts_with(t.tx_hash, '0x1_this_is_an_example_query')";
        case 'ETH_TESTNET':
        case 'ETH_MAINNET':
            return "SELECT 1 FROM transactions t WHERE starts_with(t.tx_hash, '0x1_this_is_an_example_query')";
        case 'APTOS_TESTNET':
        case 'APTOS_MAINNET':
            // return `SELECT * FROM transactions`
            return "SELECT 1 FROM transactions t WHERE starts_with(t.hash, '0x1_this_is_an_example_query')";
        default:
            return "SELECT 1 FROM transactions";
    }
}
function getCustomSdkPackage(type) {
    switch (type) {
        case 'SUI_MAINNET':
        case 'SUI_TESTNET':
            return "@mamoru-ai/mamoru-sui-sdk-as";
        case 'BSC_TESTNET':
        case 'BSC_MAINNET':
            return "@mamoru-ai/mamoru-evm-sdk-as";
        case 'ETH_TESTNET':
        case 'ETH_MAINNET':
            return "@mamoru-ai/mamoru-evm-sdk-as";
        case 'APTOS_TESTNET':
        case 'APTOS_MAINNET':
            return "@mamoru-ai/mamoru-aptos-sdk-as";
        default:
            return "@mamoru-ai/mamoru-evm-sdk-as";
    }
}
function getCustomSdkPackageVersion(type) {
    switch (type) {
        case 'SUI_MAINNET':
        case 'SUI_TESTNET':
            return sdk_dependency_versions_1.sdkVersions.sui;
        case 'BSC_TESTNET':
        case 'BSC_MAINNET':
        case 'ETH_TESTNET':
        case 'ETH_MAINNET':
            return sdk_dependency_versions_1.sdkVersions.evm;
        case 'APTOS_TESTNET':
        case 'APTOS_MAINNET':
            return sdk_dependency_versions_1.sdkVersions.aptos;
        default:
            return sdk_dependency_versions_1.sdkVersions.evm;
    }
}
function getCustomSdkCtxName(type) {
    switch (type) {
        case 'SUI_MAINNET':
        case 'SUI_TESTNET':
            return "SuiCtx";
        case 'BSC_TESTNET':
        case 'BSC_MAINNET':
        case 'ETH_TESTNET':
        case 'ETH_MAINNET':
            return "EvmCtx";
        case 'APTOS_TESTNET':
        case 'APTOS_MAINNET':
            return "AptosCtx";
        default:
            return "EvmCtx";
    }
}
function getFilesToCreate(projectPath, ops) {
    var files = __assign({}, constants_1.FILES);
    if (ops.type === 'sql') {
        delete files.WASM_INDEX;
        delete files.WASM_TEST;
    }
    if (ops.type === 'wasm') {
        delete files.QUERIES;
    }
    var fileDirs = {};
    Object.entries(files).forEach(function (_a) {
        var key = _a[0], name = _a[1];
        // eslint-disable-next-line @typescript-eslint/ban-ts-comment
        // @ts-ignore
        fileDirs[key] = path_1.default.join(projectPath, name);
    });
    return fileDirs;
}
function createFile(logger, ops, templatePath, targetPath) {
    var targetFileName = path_1.default.basename(targetPath);
    logger.verbose("Creating \"".concat(targetFileName, "\""));
    var absoluteTemplatePath = path_1.default.join(__dirname, templatePath);
    logger.verbose('CREATING FILE', absoluteTemplatePath);
    var templateSrc = fs.readFileSync(absoluteTemplatePath).toString('utf-8');
    var template = handlebars_1.default.compile(templateSrc);
    var result = template(ops);
    fs.writeFileSync(targetPath, result);
}
function createFolder(logger, projectPath, folderPath) {
    var folderName = path_1.default.basename(folderPath);
    logger.verbose("Creating \"".concat(folderName, "\" folder"));
    if (!fs.existsSync(path_1.default.join(projectPath, folderPath))) {
        fs.mkdirSync(path_1.default.join(projectPath, folderName));
    }
}
exports.default = {
    init: init,
    getAugmentedInitOptions: getAugmentedInitOptions,
};
//# sourceMappingURL=init.js.map