"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = __importStar(require("fs"));
var path_1 = __importDefault(require("path"));
var handlebars_1 = __importDefault(require("handlebars"));
var console_1 = require("../services/console");
var dashify_1 = __importDefault(require("dashify"));
var colors_1 = __importDefault(require("colors"));
var lodash_1 = require("lodash");
var constants_1 = require("../services/constants");
var utils_1 = require("../services/utils");
function initPlaybook(program, projectPath, options) {
    return __awaiter(this, void 0, void 0, function () {
        var verbosity, logger, augOps, files;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    verbosity = program.opts().verbose;
                    logger = new console_1.Logger(verbosity);
                    logger.verbose('Run playbook init');
                    logger.verbose('options', options);
                    logger.verbose('projectPath', projectPath);
                    return [4 /*yield*/, getAugmentedInitOptions(options, projectPath)];
                case 1:
                    augOps = _a.sent();
                    files = getFilesToCreate(projectPath);
                    (0, utils_1.checkFolderEmptiness)(program, Object.values(files));
                    logger.ok('Creating Mamoru project files');
                    createFile(logger, augOps, constants_1.PLAYBOOK_TEMPLATES.PLAYBOOK_YAML, files.PLAYBOOK_YAML);
                    createFile(logger, augOps, constants_1.PLAYBOOK_TEMPLATES.README, files.README);
                    createFile(logger, augOps, constants_1.PLAYBOOK_TEMPLATES.GITIGNORE, files.GITIGNORE);
                    logger.ok('Mamoru project files created!');
                    logger.log("\n    \u2139\uFE0F To start working on your project, run:\n        \n        ".concat(colors_1.default.grey("cd ".concat(projectPath)), "\n    \n    \u2139\uFE0F To know more about how to create your own playbook, visit:\n        \n        ").concat(colors_1.default.underline.blue('https://mamoru-foundation.github.io/guides/using-the-mamoru-cli.html'), "\n    "));
                    return [2 /*return*/];
            }
        });
    });
}
//
function getAugmentedInitOptions(options, projectPath) {
    return __awaiter(this, void 0, void 0, function () {
        var name;
        return __generator(this, function (_a) {
            if (!options.name && !(0, dashify_1.default)(projectPath)) {
                name = 'Default Playbook name';
            }
            else {
                name = options.name || (0, lodash_1.deburr)(path_1.default.basename(projectPath));
            }
            return [2 /*return*/, __assign(__assign({}, options), { name: name, kebabName: (0, dashify_1.default)(name) })];
        });
    });
}
function getFilesToCreate(projectPath) {
    var fileDirs = {};
    Object.entries(constants_1.PLAYBOOK_FILES).forEach(function (_a) {
        var key = _a[0], name = _a[1];
        fileDirs[key] = path_1.default.join(projectPath, name);
    });
    return fileDirs;
}
function createFile(logger, ops, templatePath, targetPath) {
    var targetFileName = path_1.default.basename(targetPath);
    logger.verbose("Creating \"".concat(targetFileName, "\""));
    var absoluteTemplatePath = path_1.default.join(__dirname, templatePath);
    logger.verbose('CREATING FILE', absoluteTemplatePath);
    var templateSrc = fs.readFileSync(absoluteTemplatePath).toString('utf-8');
    var template = handlebars_1.default.compile(templateSrc);
    var result = template(ops);
    fs.writeFileSync(targetPath, result);
}
exports.default = {
    initPlaybook: initPlaybook,
    getAugmentedInitOptions: getAugmentedInitOptions,
    getFilesToCreate: getFilesToCreate,
    createFile: createFile,
};
//# sourceMappingURL=playbook-init.js.map