"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PLAYBOOK_FILES = exports.PLAYBOOK_TEMPLATES = exports.MAMORU_VERSION_KEY = exports.DEFAULT_MAMORU_VERSION = exports.MAMORU_EXPLORER_URL = exports.ONLY_ALPHA_NUMERIC = exports.FILES = exports.TEMPLATES = exports.WASM_INDEX = exports.OUT_DIR = void 0;
exports.OUT_DIR = 'build';
exports.WASM_INDEX = 'index.wasm';
var BASE_DIR = process.env.NODE_ENV === 'test' ? '../' : '../';
exports.TEMPLATES = {
    PACKAGE_JSON: BASE_DIR + 'templates/init/package.json.hbs',
    MANIFEST: BASE_DIR + 'templates/init/manifest.yml.hbs',
    QUERIES: BASE_DIR + 'templates/init/queries.yml.hbs',
    WASM_INDEX: BASE_DIR + 'templates/init/src/index.ts.hbs',
    WASM_TEST: BASE_DIR + 'templates/init/test/index.spec.ts.hbs',
    README: BASE_DIR + 'templates/init/readme.md.hbs',
    GITIGNORE: BASE_DIR + 'templates/init/gitignore.hbs',
};
exports.FILES = {
    PACKAGE_JSON: 'package.json',
    MANIFEST: 'manifest.yml',
    QUERIES: 'queries.yml',
    WASM_INDEX: 'src/index.ts',
    WASM_TEST: 'test/index.spec.ts',
    README: 'readme.md',
    GITIGNORE: '.gitignore',
};
exports.ONLY_ALPHA_NUMERIC = /^[a-zA-Z0-9]+$/;
exports.MAMORU_EXPLORER_URL = 'https://mamoru.ai';
exports.DEFAULT_MAMORU_VERSION = '0.1.0';
exports.MAMORU_VERSION_KEY = 'mamoru';
exports.PLAYBOOK_TEMPLATES = {
    PLAYBOOK_YAML: BASE_DIR + 'templates/playbook/playbook.yml.hbs',
    README: BASE_DIR + 'templates/playbook/readme.md.hbs',
    GITIGNORE: BASE_DIR + 'templates/playbook/gitignore.hbs',
};
exports.PLAYBOOK_FILES = {
    PLAYBOOK_YAML: 'playbook.yml',
    README: 'readme.md',
    GITIGNORE: '.gitignore',
};
//# sourceMappingURL=constants.js.map