"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isValidPlaybookManifest = void 0;
var joi_1 = __importDefault(require("joi"));
var utils_1 = require("./utils");
var playbookSchema = joi_1.default.object({
    name: joi_1.default.string().required(),
    on: joi_1.default.array().items(joi_1.default.object({
        daemonId: joi_1.default.string(),
        levels: joi_1.default.array().items(joi_1.default.string()).min(1),
    })),
    tasks: joi_1.default.object().required(),
});
var isValidPlaybookManifest = function (logger, program, playbook) {
    logger.ok("Validating Playbook content");
    var error = playbookSchema.validate(playbook, { abortEarly: false }).error;
    if (error) {
        var formatted = (0, utils_1.formatJoiError)(error);
        logger.error(formatted);
        program.error(formatted);
        return false;
    }
    return true;
};
exports.isValidPlaybookManifest = isValidPlaybookManifest;
//# sourceMappingURL=playbook.js.map