"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var joi_1 = __importDefault(require("joi"));
var fs = __importStar(require("fs"));
var path = __importStar(require("path"));
var yaml_1 = __importDefault(require("yaml"));
var utils_1 = require("./utils");
var constants_1 = require("./constants");
var incident_1 = require("@mamoru-ai/validation-chain-ts-client/dist/validationchain.validationchain/types/validationchain/validationchain/incident");
var QueryManifestService = /** @class */ (function () {
    function QueryManifestService() {
        var _a;
        this.fileSchema = joi_1.default.object({
            version: joi_1.default.string().optional(),
            queries: joi_1.default.array().items(joi_1.default.object({
                query: joi_1.default.string().required(),
                severity: (_a = joi_1.default
                    .string())
                    .valid.apply(_a, Object.values(incident_1.IncidentSeverity).filter(function (v) {
                    return typeof v === 'string' &&
                        v !== '' &&
                        v !== 'UNRECOGNIZED';
                })).required(),
                incidentMessage: joi_1.default.string().required(),
            })),
        });
    }
    QueryManifestService.prototype.getFile = function (logger, projectPath) {
        var p = path.join(projectPath, constants_1.FILES.QUERIES);
        logger.verbose("Checking if \"".concat(p, "\" exists"));
        if (!fs.existsSync(p)) {
            throw new Error('queries.yml file not found');
        }
        return fs.readFileSync(p, 'utf-8');
    };
    QueryManifestService.prototype.parseFile = function (file) {
        return yaml_1.default.parse(file);
    };
    QueryManifestService.prototype.get = function (logger, projectPath) {
        var file = this.getFile(logger, projectPath);
        var parsed = this.parseFile(file);
        this.validateFile(parsed);
        return parsed;
    };
    QueryManifestService.prototype.validateFile = function (file) {
        var error = this.fileSchema.validate(file).error;
        if (error) {
            var formatted = (0, utils_1.formatJoiError)(error);
            throw new Error(formatted);
        }
    };
    return QueryManifestService;
}());
exports.default = new QueryManifestService();
//# sourceMappingURL=query-manifest.js.map