"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var program_1 = __importDefault(require("../program"));
var fs_1 = __importDefault(require("fs"));
function generateMarkdown() {
    var commands = program_1.default.commands;
    var markdown = commands.reduce(function (acc, command) {
        return "".concat(acc, " \n### ").concat(command.name(), "\n\n```\n").concat(command.helpInformation(), "\n```\n");
    }, '');
    return "# Mamoru CLI Reference\n\n## Basic Usage\n\n```\n".concat(getBasicUsage(program_1.default), "\n```\n\n## Commands\n\n").concat(markdown);
}
function getBasicUsage(program) {
    return program
        .helpInformation()
        .replace('Usage: ', 'mamoru-cli')
        .split('Commands:')[0]
        .trim();
}
function generateDocs() {
    var docsPath = path_1.default.resolve(__dirname, '../../docs/reference.md');
    fs_1.default.writeFileSync(docsPath, generateMarkdown());
}
generateDocs();
//# sourceMappingURL=generate-docs.js.map