"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sdkVersionsFromMap = exports.getSdkVersions = exports.extractSdkVersions = exports.queryDaemonParameters = exports.validateAndParseParameterFlag = exports.runCommand = void 0;
var node_child_process_1 = require("node:child_process");
var chain_1 = require("@mamoru-ai/validation-chain-ts-client/dist/validationchain.validationchain/types/validationchain/validationchain/chain");
var prompts_1 = require("@inquirer/prompts");
var node_path_1 = __importDefault(require("node:path"));
var fs = __importStar(require("fs"));
var runCommand = function (cmd) {
    return new Promise(function (resolve, reject) {
        var child = (0, node_child_process_1.exec)(cmd, function (err) {
            // eslint-disable-next-line no-console
            if (err) {
                reject(err);
            }
            resolve(undefined);
        });
        child.stderr.pipe(process.stderr);
        child.stdout.pipe(process.stdout);
    });
};
exports.runCommand = runCommand;
function validateAndParseParameterFlag(parameters) {
    if (!parameters)
        return {};
    var parsed;
    try {
        parsed = JSON.parse(parameters);
    }
    catch (error) {
        throw new Error('Parameters must be a valid JSON string');
    }
    if (typeof parsed !== 'object') {
        throw new Error('Parameters must be an object');
    }
    if (Array.isArray(parsed)) {
        throw new Error('Parameters must be an object');
    }
    return parsed;
}
exports.validateAndParseParameterFlag = validateAndParseParameterFlag;
function queryDaemonParameters(metadata, options, chain) {
    return __awaiter(this, void 0, void 0, function () {
        var chainType, parameters, result, _i, parameters_1, parameter, answer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (options.parameters)
                        return [2 /*return*/, validateAndParseParameterFlag(options.parameters)];
                    chainType = (0, chain_1.chain_ChainTypeFromJSON)(chain);
                    parameters = metadata.parameters.filter(function (el) {
                        if (el.hiddenFor.map(function (el) { return el.chainType; }).includes(chainType))
                            return false;
                        return true;
                    });
                    result = {};
                    _i = 0, parameters_1 = parameters;
                    _a.label = 1;
                case 1:
                    if (!(_i < parameters_1.length)) return [3 /*break*/, 4];
                    parameter = parameters_1[_i];
                    return [4 /*yield*/, (0, prompts_1.input)({
                            message: "Enter value for parameter \"".concat(parameter.key, "\""),
                            default: parameter.defaultValue,
                        })];
                case 2:
                    answer = _a.sent();
                    result[parameter.key] = answer;
                    _a.label = 3;
                case 3:
                    _i++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/, result];
            }
        });
    });
}
exports.queryDaemonParameters = queryDaemonParameters;
function readPackageJson(logger, buildPath) {
    var packageJsonPath = node_path_1.default.join(buildPath, 'package.json');
    if (!fs.existsSync(packageJsonPath)) {
        throw new Error('package.json not found, please make sure you have a package.json in the root of your project');
    }
    var packageJson = JSON.parse(fs.readFileSync(packageJsonPath, { encoding: 'utf-8' }));
    return packageJson;
}
/**
 * Export for testing
 */
function extractSdkVersions(packageJson) {
    var depPrefix = '@mamoru-ai/';
    var dependencies = packageJson.dependencies || {};
    var sdkVersions = [];
    for (var dep in dependencies) {
        if (dep.startsWith(depPrefix)) {
            sdkVersions.push({
                sdk: dep,
                version: extractPureSemver(dependencies[dep]),
            });
        }
    }
    return sdkVersions;
}
exports.extractSdkVersions = extractSdkVersions;
function extractPureSemver(packageVersion) {
    var split = packageVersion.split('-');
    if (split.length > 1) {
        split[0] = split[0].replace(/[^0-9.]/g, '');
        return split.join('-');
    }
    var version = packageVersion.replace(/[^0-9.]/g, '');
    return version;
}
function getSdkVersions(logger, buildPath) {
    var packageJson = readPackageJson(logger, buildPath);
    return extractSdkVersions(packageJson);
}
exports.getSdkVersions = getSdkVersions;
function sdkVersionsFromMap(sdkVersions) {
    var result = [];
    if (sdkVersions === undefined) {
        return result;
    }
    Object.entries(sdkVersions).forEach(function (_a) {
        var sdk = _a[0], version = _a[1];
        result.push({
            sdk: sdk,
            version: version,
        });
    });
    return result;
}
exports.sdkVersionsFromMap = sdkVersionsFromMap;
//# sourceMappingURL=utils.js.map